diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index d1594da1b..40b7fd06f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -429,7 +429,7 @@ public final class Blocks {
 
     public static final @NotNull Block<?> BEDROCK = register("bedrock", "minecraft:block/bedrock", 260, (b) -> new BlockLogicBedrock(b, Materials.STONE))
         .withSound(BlockSounds.STONE).withSetUnbreakable().withBlastResistance(6000000F).withImmovableFlagSet()
-        .withTags(BlockTags.PISTON_CRUSHING, BlockTags.CHAINLINK_FENCES_CONNECT);
+        .withTags(BlockTags.PISTON_CRUSHING, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS);
     public static final @NotNull Block<?> BONESHALE = register("boneshale", "minecraft:block/boneshale", 261, (b) -> new BlockLogicBoneShale(b, Materials.STONE))
         .withSound(BlockSounds.STONE).withHardness(16F).withBlastResistance(6000000F).withImmovableFlagSet()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN);
@@ -790,10 +790,10 @@ public final class Blocks {
         .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final @NotNull Block<BlockLogicMotionSensor> MOTION_SENSOR_IDLE = register("motionsensor.idle", "minecraft:block/motion_sensor_idle", 500, (BlockLogicSupplier<BlockLogicMotionSensor>)(b) -> new BlockLogicMotionSensor(b, false))
-        .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.stone)
+        .withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.stone)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT);
     public static final @NotNull Block<BlockLogicMotionSensor> MOTION_SENSOR_ACTIVE = register("motionsensor.active", "minecraft:block/motion_sensor_active", 501, (BlockLogicSupplier<BlockLogicMotionSensor>)(b) -> new BlockLogicMotionSensor(b, true))
-        .withSound(BlockSounds.STONE).withLightEmission(0.3F).withHardness(2.0F).withBlastResistance(10F).withOverrideColor(MaterialColor.stone).setStatParent(() -> MOTION_SENSOR_IDLE)
+        .withSound(BlockSounds.STONE).withLightEmission(0.3F).withHardness(1.5F).withBlastResistance(10F).withOverrideColor(MaterialColor.stone).setStatParent(() -> MOTION_SENSOR_IDLE)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT);
 
     public static final @NotNull Block<BlockLogicRepeater> REPEATER_IDLE = register("repeater.idle", "minecraft:block/repeater_idle", 510, (BlockLogicSupplier<BlockLogicRepeater>)b -> new BlockLogicRepeater(b, false))
@@ -848,11 +848,11 @@ public final class Blocks {
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final @NotNull Block<?> DISPENSER_COBBLE_STONE = register("dispenser.cobble.stone", "minecraft:block/dispenser_cobble_stone", 560, BlockLogicDispenser::new)
-        .withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        .withSound(BlockSounds.STONE).withHardness(1.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS, BlockTags.CHAINLINK_FENCES_CONNECT);
     public static final @NotNull Block<?> ACTIVATOR_COBBLE_NETHERRACK = register("activator.cobble.netherrack", "minecraft:block/activator_cobble_netherrack", 561, BlockLogicActivator::new)
-        .withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        .withSound(BlockSounds.STONE).withHardness(1.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final @NotNull Block<?> TRAPDOOR_PLANKS_OAK = register("trapdoor.planks.oak", "minecraft:block/trapdoor_planks_oak", 570, (b) -> new BlockLogicTrapDoor(b, Materials.WOOD))
         .withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
@@ -1142,9 +1142,9 @@ public final class Blocks {
         .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
-    public static final Block<?> RUBYGLASS_CIRCUIT = register("rubyglass.circuit", "minecraft:block/rubyglass_circuit", 824, (b) -> new BlockLogic(b, Materials.STONE))
-        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withHardness(1F)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN)
+    public static final Block<BlockLogicRubyglassConduit> RUBYGLASS_CONDUIT = register("rubyglass.conduit", "minecraft:block/rubyglass_conduit", 824, (BlockLogicSupplier<BlockLogicRubyglassConduit>) b -> new BlockLogicRubyglassConduit(b, Materials.STONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS)
         .withOverrideColor(MaterialColor.rubyglass);
 
     public static final Block<?> RUBYGLASS_NODE = register("rubyglass.node", "minecraft:block/rubyglass_node", 826, (b) -> new BlockLogicOreRubyglass(b))
@@ -1373,11 +1373,11 @@ public final class Blocks {
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final @NotNull Block<BlockLogic> MATCHER = register("matcher", "minecraft:block/matcher", 1040, (b) -> new BlockLogicMatcher(b, false))
-        .withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        .withSound(BlockSounds.STONE).withHardness(1.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS);
     public static final @NotNull Block<BlockLogic> MATCHER_ACTIVE = register("matcher.active", "minecraft:block/matcher_active", 1041, (b) -> new BlockLogicMatcher(b, true))
-        .withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+        .withSound(BlockSounds.STONE).withHardness(1.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final @NotNull Block<BlockLogicStairs> STAIRS_BRICK_DIAMOND = register("stairs.brick.diamond", "minecraft:block/stairs_brick_diamond", 1049, (BlockLogicSupplier<BlockLogicStairs>)b -> new BlockLogicStairs(b, Blocks.BRICK_DIAMOND))
         .withSound(BlockSounds.PERMAFROST).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index be9c13798..67bee6f83 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -4,27 +4,24 @@ import java.util.*;
 
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.motion.CarriedBlock;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.save.conversion.ItemConverters;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
+import static net.minecraft.core.world.save.conversion.ItemConverters.legacyBucketConverter;
+
 public class TileEntityBasket extends TileEntity {
     private int numUnitsInside = 0;
     private final Object2IntMap<BasketEntry> contents = new Object2IntArrayMap<>();
@@ -51,6 +48,9 @@ public class TileEntityBasket extends TileEntity {
     }
 
     private int getItemSizeUnits(final Item item) {
+        if (item == null) {
+            return 0;
+        }
         return 64 / item.getItemStackLimit(null);
     }
 
@@ -255,6 +255,9 @@ public class TileEntityBasket extends TileEntity {
         }
 
         public static BasketEntry read(final CompoundTag tag) {
+
+            legacyBucketConverter(tag);
+
             final int id = tag.getShort("id");
             final int damage = tag.getShort("Damage");
             final CompoundTag data = tag.getCompound("Data");
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index f2fab04d6..3a407f60c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -12,6 +12,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.PacketTileEntityData;
@@ -19,7 +20,6 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -172,45 +172,45 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         boolean isBurnTimeHigherThan0 = currentBurnTime > 0;
         boolean furnaceUpdated = false;
 
-        if(currentBurnTime > 0)
-        {
+        if(currentBurnTime > 0) {
             currentBurnTime--;
         }
-        if(worldObj == null || !worldObj.isClientSide)
-        {
-        	if(worldObj == null || worldObj.getBlockId(tilePos.x, tilePos.y, tilePos.z) == Blocks.FURNACE_STONE_IDLE.id()) {
-            	if(currentBurnTime == 0 && furnaceItemStacks[SLOT_INGREDIENT] == null) {
-            		if(furnaceItemStacks[SLOT_FUEL] != null && furnaceItemStacks[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
-            			furnaceItemStacks[SLOT_FUEL].stackSize--;
-            			if(furnaceItemStacks[SLOT_FUEL].stackSize <= 0) furnaceItemStacks[SLOT_FUEL] = null;
-            			updateFurnace(true);
-            			furnaceUpdated = true;
-            		}
-            	}
-        	}
-        	
-            if(currentBurnTime == 0 && furnaceItemStacks[SLOT_FUEL] != null && canSmelt())
-            {
+
+        if(worldObj == null || !worldObj.isClientSide) {
+            if(worldObj == null || worldObj.getBlockId(tilePos.x, tilePos.y, tilePos.z) == Blocks.FURNACE_STONE_IDLE.id()) {
+                if(currentBurnTime == 0 && furnaceItemStacks[SLOT_INGREDIENT] == null) {
+                    if(furnaceItemStacks[SLOT_FUEL] != null && furnaceItemStacks[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
+                        furnaceItemStacks[SLOT_FUEL].stackSize--;
+                        if(furnaceItemStacks[SLOT_FUEL].stackSize <= 0) furnaceItemStacks[SLOT_FUEL] = null;
+                        updateFurnace(true);
+                        furnaceUpdated = true;
+                    }
+                }
+            }
+
+            if(currentBurnTime == 0 && furnaceItemStacks[SLOT_FUEL] != null && canSmelt()) {
                 maxBurnTime = currentBurnTime = getBurnTimeFromItem(furnaceItemStacks[SLOT_FUEL]);
-                if(currentBurnTime > 0)
-                {
+                if(currentBurnTime > 0) {
                     furnaceUpdated = true;
-                    if(furnaceItemStacks[SLOT_FUEL] != null)
-                    {
-                        if (furnaceItemStacks[SLOT_FUEL].getItem() == Items.BUCKET_LAVA)
-                        {
-                            furnaceItemStacks[SLOT_FUEL] = new ItemStack(Items.BUCKET);
+
+                    if(furnaceItemStacks[SLOT_FUEL] != null) {
+                        ItemStack fuelStack = furnaceItemStacks[SLOT_FUEL];
+
+                        if (fuelStack.getItem() instanceof ItemBucket && ItemBucket.getState(fuelStack) == ItemBucket.STATE_LAVA) {
+
+                            ItemBucket.setCharges(fuelStack, ItemBucket.getCharges(fuelStack) - 1);
+
+                            if (ItemBucket.getCharges(fuelStack) == 0) {
+                                ItemBucket.setState(fuelStack, ItemBucket.STATE_EMPTY);
+                            }
                         }
-                        else
-                        {
-                            furnaceItemStacks[SLOT_FUEL].stackSize--;
-                            if(furnaceItemStacks[SLOT_FUEL].stackSize <= 0)
-                            {
+                        else {
+                            fuelStack.stackSize--;
+                            if(fuelStack.stackSize <= 0) {
                                 furnaceItemStacks[SLOT_FUEL] = null;
                             }
                         }
@@ -218,26 +218,24 @@ public class TileEntityFurnace extends TileEntity
                 }
             }
 
-            if(isBurning() && canSmelt())
-            {
+            if(isBurning() && canSmelt()) {
                 currentCookTime++;
-                if(currentCookTime == maxCookTime)
-                {
+                if(currentCookTime == maxCookTime) {
                     currentCookTime = 0;
                     smeltItem();
                     furnaceUpdated = true;
                 }
-            } else
+            } else {
                 currentCookTime = 0;
+            }
 
-            if(isBurnTimeHigherThan0 != (currentBurnTime > 0))
-            {
+            if(isBurnTimeHigherThan0 != (currentBurnTime > 0)) {
                 furnaceUpdated = true;
                 updateFurnace(false);
             }
         }
-        if(furnaceUpdated)
-        {
+
+        if(furnaceUpdated) {
             setChanged();
         }
     }
@@ -317,11 +315,9 @@ public class TileEntityFurnace extends TileEntity
         }
     }
 
-    private int getBurnTimeFromItem(ItemStack itemStack)
-    {
-        if(itemStack == null)
-            return 0;
-        return LookupFuelFurnace.instance.getFuelYield(itemStack.getItem().id);
+    private int getBurnTimeFromItem(ItemStack itemStack) {
+        if (itemStack == null) return 0;
+        return LookupFuelFurnace.instance.getFuelYield(itemStack);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 209aeb4bf..5414b53e6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -279,10 +279,9 @@ public class TileEntityFurnaceBlast extends TileEntity
         }
     }
 
-    private int getBurnTimeFromItem(final ItemStack itemStack) {
-        if (itemStack == null)
-            return 0;
-        return LookupFuelFurnaceBlast.instance.getFuelYield(itemStack.getItem().id);
+    private int getBurnTimeFromItem(ItemStack itemStack) {
+        if (itemStack == null) return 0;
+        return LookupFuelFurnaceBlast.instance.getFuelYield(itemStack);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index cf28b7b55..39d1731ce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -11,7 +11,6 @@ import net.minecraft.core.block.BlockLogicTrommel;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.crafting.LookupFuelFurnace;
-import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
@@ -19,15 +18,14 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.monster.MobSlime;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.save.LevelStorageDummy;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -214,23 +212,27 @@ public class TileEntityTrommel extends TileEntity
             if(!canProduce(SLOTS_INGREDIENT[this.nextToSieve])) {
                 this.nextToSieve = (this.nextToSieve + 1) % SLOTS_INGREDIENT.length;
             }
-            if(this.burnTime == 0 && canProduce(SLOTS_INGREDIENT[this.nextToSieve]))
-            {
+            if(this.burnTime == 0 && canProduce(SLOTS_INGREDIENT[this.nextToSieve])) {
                 this.currentItemBurnTime = this.burnTime = getItemBurnTime(this.itemStacks[SLOT_FUEL]);
-                if(this.burnTime > 0)
-                {
+
+                if(this.burnTime > 0) {
                     flag1 = true;
-                    if(this.itemStacks[SLOT_FUEL] != null)
-                    {
-                    	if(this.itemStacks[SLOT_FUEL].getItem() == Items.BUCKET_LAVA) {
-                            this.itemStacks[SLOT_FUEL] = new ItemStack(Items.BUCKET);
-                    	}else {
-                            this.itemStacks[SLOT_FUEL].stackSize--;
-                            if(this.itemStacks[SLOT_FUEL].stackSize <= 0)
-                            {
+                    if(this.itemStacks[SLOT_FUEL] != null) {
+                        ItemStack fuelStack = this.itemStacks[SLOT_FUEL];
+
+                        if (fuelStack.getItem() instanceof ItemBucket && ItemBucket.getState(fuelStack) == ItemBucket.STATE_LAVA) {
+
+                            ItemBucket.setCharges(fuelStack, ItemBucket.getCharges(fuelStack) - 1);
+
+                            if (ItemBucket.getCharges(fuelStack) == 0) {
+                                ItemBucket.setState(fuelStack, ItemBucket.STATE_EMPTY);
+                            }
+                        } else {
+                            fuelStack.stackSize--;
+                            if(fuelStack.stackSize <= 0) {
                                 this.itemStacks[SLOT_FUEL] = null;
                             }
-                    	}
+                        }
                     }
                 }
             }
@@ -408,9 +410,8 @@ public class TileEntityTrommel extends TileEntity
 
     private int getItemBurnTime(ItemStack itemStack)
     {
-        if(itemStack == null)
-            return 0;
-        return LookupFuelFurnace.instance.getFuelYield(itemStack.getItem().id);
+        if(itemStack == null) return 0;
+        return LookupFuelFurnace.instance.getFuelYield(itemStack);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
index 1ca5ca011..addeb075d 100644
--- a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
@@ -3,15 +3,19 @@ package net.minecraft.core.crafting;
 import it.unimi.dsi.fastutil.ints.Int2IntMap;
 import it.unimi.dsi.fastutil.ints.Int2IntOpenHashMap;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.block.Blocks;
 
-import java.util.HashMap;
+import java.util.LinkedHashMap;
 import java.util.Map;
+import java.util.function.Predicate;
 
 public class LookupFuelFurnace {
 
 	public static final LookupFuelFurnace instance = new LookupFuelFurnace();
 	protected final Int2IntMap fuelList = new Int2IntOpenHashMap();
+	protected final Map<Predicate<ItemStack>, Integer> advancedFuelList = new LinkedHashMap<>();
 
 	protected LookupFuelFurnace() {
 		register();
@@ -83,17 +87,33 @@ public class LookupFuelFurnace {
 		addFuelEntry(Items.COAL.id, 1600);
 		addFuelEntry(Items.NETHERCOAL.id, 6400);
 
-		addFuelEntry(Items.BUCKET_LAVA.id, 20000);
+		addAdvancedFuelEntry(stack -> stack.getItem() instanceof ItemBucket && ItemBucket.getState(stack) == ItemBucket.STATE_LAVA, 12800);
 	}
 
 	public void addFuelEntry(int id, int fuelYield) {
 		fuelList.put(id, fuelYield);
 	}
 
+	public void addAdvancedFuelEntry(Predicate<ItemStack> condition, int fuelYield) {
+		advancedFuelList.put(condition, fuelYield);
+	}
+
 	public int getFuelYield(int id) {
 		return fuelList.getOrDefault(id, 0);
 	}
 
+	public int getFuelYield(ItemStack stack) {
+		if (stack == null) return 0;
+
+		for (Map.Entry<Predicate<ItemStack>, Integer> entry : advancedFuelList.entrySet()) {
+			if (entry.getKey().test(stack)) {
+				return entry.getValue();
+			}
+		}
+
+		return getFuelYield(stack.getItem().id);
+	}
+
 	public Int2IntMap getFuelList() {
 		return fuelList;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/current/conduit/ConduitHandler.java b/game/core/src/main/java/net/minecraft/core/current/conduit/ConduitHandler.java
new file mode 100644
index 000000000..d0a6ea9b8
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/conduit/ConduitHandler.java
@@ -0,0 +1,181 @@
+package net.minecraft.core.current.conduit;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogicRubyglassConduit;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
+import java.util.*;
+
+
+/**
+ * One-Dimensional Implementation of Alternate Current for rubyglass conduits. <div></div>
+ * Handles the logic and updates for any given conduit network and seamlessly integrates with other redstone components. <div></div>
+ *
+ * @author Melon Mojito (@melon_mojito)
+ */
+public class ConduitHandler {
+    private final World world;
+    private boolean updating = false;
+    private final Queue<TilePos> updateQueue = new LinkedList<>();
+
+    public ConduitHandler(World world) {
+        this.world = world;
+    }
+
+    public void onConduitUpdated(TilePosc pos) {
+        queueUpdate(new TilePos(pos));
+    }
+
+    public void onConduitAdded(TilePosc pos) {
+        queueUpdate(new TilePos(pos));
+    }
+
+    public void onConduitRemoved(TilePosc pos, int oldData) {
+        //update the sides this conduit was connected to
+        for (Side side : BlockLogicRubyglassConduit.getOpenSides(oldData)) {
+            TilePos nPos = new TilePos(pos).add(side);
+            if (world.getBlockType(nPos) == Blocks.RUBYGLASS_CONDUIT) {
+                queueUpdate(nPos);
+            }
+        }
+    }
+
+    private void queueUpdate(TilePos pos) {
+        updateQueue.add(pos);
+        if (!updating) {
+            processQueue();
+        }
+    }
+
+    private void processQueue() {
+        updating = true;
+        try {
+            while (!updateQueue.isEmpty()) {
+                TilePos startPos = updateQueue.poll();
+                // Ensure the block is still a conduit before updating the network,
+                // as it could have been broken while sitting in the queue.
+                if (world.getBlockType(startPos) == Blocks.RUBYGLASS_CONDUIT) {
+                    updateNetwork(startPos);
+                }
+            }
+        } finally {
+            updating = false;
+        }
+    }
+
+    private void updateNetwork(TilePos startPos) {
+        //build the network
+        Set<TilePos> network = new HashSet<>();
+        Queue<TilePos> toSearch = new LinkedList<>();
+        toSearch.add(startPos);
+
+        while (!toSearch.isEmpty()) {
+            TilePos pos = toSearch.poll();
+            if (network.add(pos)) {
+                int data = world.getBlockData(pos);
+                for (Side side : BlockLogicRubyglassConduit.getOpenSides(data)) {
+                    TilePos nPos = new TilePos(pos).add(side);
+                    if (world.getBlockType(nPos) == Blocks.RUBYGLASS_CONDUIT &&
+                            BlockLogicRubyglassConduit.isSideOpen(world.getBlockData(nPos), side.getOpposite())) {
+                        toSearch.add(nPos);
+                    }
+                }
+            }
+        }
+
+        //external sources: levers, buttons, etc.
+        Map<TilePos, Integer> externalPower = new HashMap<>();
+        for (TilePos tilePos : network) {
+            int data = world.getBlockData(tilePos);
+            int currentPower = data / BlockLogicRubyglassConduit.STATE_COUNT;
+            int maxExternalPower = 0;
+
+            for (Side side : BlockLogicRubyglassConduit.getOpenSides(data)) {
+                TilePos nTilePos = new TilePos(tilePos).add(side);
+                Block<?> nBlockType = world.getBlockType(nTilePos);
+
+                if (nBlockType != Blocks.RUBYGLASS_CONDUIT) {
+                    int external = BlockLogicRubyglassConduit.getAndConvertNeighborSignal(world, tilePos, side);
+
+                    //break the recursive loop for redstone dust
+                    if (nBlockType == Blocks.WIRE_REDSTONE) {
+                        if (external < currentPower) {
+                            external = 0;
+                        }
+                    }
+
+                    if (external > maxExternalPower) maxExternalPower = external;
+                }
+            }
+            externalPower.put(tilePos, maxExternalPower);
+        }
+
+        //propagate from roots with priority
+        Map<TilePos, Integer> newPowerLevels = new HashMap<>();
+        for (TilePos tilePos : network) newPowerLevels.put(tilePos, 0);
+
+        PriorityQueue<ConduitNode> powerQueue = new PriorityQueue<>((a, b) -> Integer.compare(b.currentPower, a.currentPower));
+        for (Map.Entry<TilePos, Integer> entry : externalPower.entrySet()) {
+            if (entry.getValue() > 0) {
+                powerQueue.add(new ConduitNode(entry.getKey(), entry.getValue()));
+            }
+        }
+
+        while (!powerQueue.isEmpty()) {
+            ConduitNode node = powerQueue.poll();
+            //ignore weaker path
+            if (node.currentPower <= newPowerLevels.get(node.tilePos)) continue;
+
+            newPowerLevels.put(node.tilePos, node.currentPower);
+
+            //propagate power down the line
+            if (node.currentPower > 1) {
+                int data = world.getBlockData(node.tilePos);
+                for (Side side : BlockLogicRubyglassConduit.getOpenSides(data)) {
+                    TilePos nPos = new TilePos(node.tilePos).add(side);
+                    if (network.contains(nPos)) {
+                        powerQueue.add(new ConduitNode(nPos, node.currentPower - 1));
+                    }
+                }
+            }
+        }
+
+        Set<TilePos> blocksToNotify = new HashSet<>();
+        for (TilePos tilePos : network) {
+            int oldData = world.getBlockData(tilePos);
+            int oldPower = oldData / BlockLogicRubyglassConduit.STATE_COUNT;
+            int newPower = newPowerLevels.get(tilePos);
+
+            if (oldPower != newPower) {
+                int state = oldData % BlockLogicRubyglassConduit.STATE_COUNT;
+
+                //suppress recursive neighbor updates while data is being set
+                world.noNeighborUpdate = true;
+                world.setBlockDataNotify(tilePos, newPower * BlockLogicRubyglassConduit.STATE_COUNT + state);
+                world.noNeighborUpdate = false;
+
+                //queue updates ONLY for blocks facing the open sides that ARE NOT conduits in this network
+                for (Side side : BlockLogicRubyglassConduit.getOpenSides(state)) {
+                    TilePos targetPos = new TilePos(tilePos).add(side);
+                    if (!network.contains(targetPos)) {
+                        blocksToNotify.add(targetPos);
+                    }
+                }
+            }
+        }
+
+        //notify all neighbors after the network is done with its logic/updates
+        for (TilePos nTilePos : blocksToNotify) {
+            Block<?> neighborBlockType = world.getBlockType(nTilePos);
+            neighborBlockType.onNeighborChanged(world, nTilePos, Blocks.RUBYGLASS_CONDUIT);
+
+            if (neighborBlockType != Blocks.WIRE_REDSTONE) {
+                world.notifyBlocksOfNeighborChange(nTilePos, Blocks.RUBYGLASS_CONDUIT);
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/current/conduit/ConduitNode.java b/game/core/src/main/java/net/minecraft/core/current/conduit/ConduitNode.java
new file mode 100644
index 000000000..2a829e0e1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/conduit/ConduitNode.java
@@ -0,0 +1,13 @@
+package net.minecraft.core.current.conduit;
+
+import net.minecraft.core.world.pos.TilePos;
+
+public class ConduitNode {
+    TilePos tilePos;
+    int currentPower;
+
+    ConduitNode(TilePos tilePos, int currentPower) {
+        this.tilePos = tilePos;
+        this.currentPower = currentPower;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
index 87ae2910b..efabe2edc 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
@@ -15,7 +15,7 @@ import java.util.Arrays;
  *
  * @author Space Walker
  */
-class Node {
+public class Node {
 
     // flags that encode the Node type
     private static final int CONDUCTOR = 0b01;
